program AVR_Increment;

{$NOSHADOW}
{ $W+ Warnings}            {Warnings off}

Device = mega128, VCC=5;

Import SysTick, IncrPort, Serport, LCDmultiPort, TWImaster, BeepPort;

From System Import LongWord, LongInt;

Define
        ProcClock     = 16000000;        {Hertz}
        SysTick       = 10;              {msec}
        StackSize     = $0064, iData;
        FrameSize     = $0064, iData;
        SerPort       = 19200, Stop2;    {Baud, StopBits|Parity}
        RxBuffer      = 8, iData;
        TxBuffer      = 8, iData;
        IncrCounter   = 32, 2;           {32bit integer, 2Phasen}
        IncrPort      = PinE, $30;       {PinE.4 + PinE.5}
        TWIpresc      = TWI_BR400;
        LCDmultiPort  = I2C_TWI;
        LCDrows_M     = 4;               {rows}
        LCDcolumns_M  = 16;              {columns per line}
        LCDtype_M     = 44780;
        BeepPort      = PortG, 4;


Implementation

{$IDATA}

{--------------------------------------------------------------}
{ Type Declarations }

type


{--------------------------------------------------------------}
{ Const Declarations }


{--------------------------------------------------------------}
{ Var Declarations }
{$IDATA}
var
  count, count1 : longint;
  rel           : longint;

{--------------------------------------------------------------}
{ functions }
procedure Init;
begin
  EnableInts;
  BeepOut(2500, 20);
  LCDsetup_M(LCD_m1);
  LCDcursor_M(LCD_m1, true, false);
  Write(LCDOut_M,  'E-LAB EvaBoard');
  LCDxy_M(LCD_m1, 0, 1);
  Write(LCDOut_M,  'Demo program');
  LCDxy_M(LCD_m1, 0, 2);
  Write(LCDOut_M,  'Increment Test');
end;

{--------------------------------------------------------------}
{ Main Program }
{$IDATA}

begin
  Init;
  SetIncrementVal($1);
  loop
    count:= GetIncrementVal;
    if count <> count1 then
      count1:= count;
      LCDxy_M(LCD_m1, 0, 3);
      Write(LCDOut_M, LongToStr(count:12));
    endif;
//    count:= GetIncrementRel;
//    ClearIncrementVal;
//    Write(DispOut, LongToStr(li:6));

  endloop;
end AVR_Increment.

